Pulp - Issue #5164

Progress Reports incorrectly update counts in error or canceled situations
07/21/2019 03:57 PM - bmbouter

Status: CLOSED - NOTABUG Start date:

Priority: Normal Due date:

Assignee: Estimated time: 0:00 hour
Category:

Sprint/Milestone: 3.0.0

Severity: 2. Medium Groomed: No
Version: Sprint Candidate: No
Platform Release: Tags:

0OS: Sprint: Sprint 59
Triaged: Yes Quarter:

Description

A user contacted me with a task status for a failed task (see below) and | noticed its progress reports looked incorrect. The
"canceled" and "errored" progress reports show done counts equal to total counts which is incorrect for a state other than
"completed".

In terms of reproducing, this was with pulp_file doing a typical sync, and it failed to find the PULP_MANIFEST. | believe the issue is in
core though here

{
" _href": "/pulp/api/v3/tasks/01£f034b0-a419-403a-88e8-b337a54c533a/",
"_created": "2019-07-18T10:40:18.520527z",
"state": "failed",
"name": "pulp_file.app.tasks.synchronizing.synchronize",
"started_at": "2019-07-18T10:40:18.665278z",
"finished_at": "2019-07-18T10:52:12.4681582",
"non_fatal_errors": [],
"error": {

"code": null,

"description": "404, message='Not Found'",

"traceback": " File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/rgq/worker.py\", 1
ine 812, in perform_job\n rv = job.perform()\n File \"/usr/local/lib/pulp/lib64/python3.6/site
-packages/rqg/job.py\", line 588, in perform\n self._result = self._execute()\n File \"/usr/loc
al/lib/pulp/lib64/python3.6/site-packages/rq/job.py\", line 594, in _execute\n return self.func
(*self.args, **self.kwargs)\n File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/pulp_file/
app/tasks/synchronizing.py\", line 45, in synchronize\n dv.create()\n File \"/usr/local/lib/pu
1p/lib64/python3.6/site-packages/pulpcore/plugin/stages/declarative_version.py\", line 169, in cre
ate\n loop.run_until_complete (pipeline)\n File \"/usr/lib64/python3.6/asyncio/base_events.py\"
, line 484, in run_until_complete\n return future.result()\n File \"/usr/local/lib/pulp/lib64/
python3.6/site-packages/pulpcore/plugin/stages/api.py\", line 209, in create_pipeline\n await a
syncio.gather (*futures)\n File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/pulpcore/plugi
n/stages/api.py\", line 43, in _ call_ \n await self.run()\n File \"/usr/local/lib/pulp/lib64/
python3.6/site-packages/pulpcore/plugin/stages/artifact_stages.py\", line 132, in run\n pb.done

+= task.result () # download_count\n File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/pu

lpcore/plugin/stages/artifact_stages.py\", line 155, in _handle_content_unit\n await asyncio.ga
ther (*downloaders_for_content)\n File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/pulpcor
e/plugin/stages/models.py\", line 78, in download\n download_result = await downloader.run (extr
a_data=self.extra_data)\n File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/pulpcore/plugi
n/download/base.py\", line 212, in run\n return await self._run(extra_data=extra_data)\n File
\"/usr/local/lib/pulp/lib64/python3.6/site-packages/backoff/_async.py\", line 131, in retry\n r
et = await target (*args, **kwargs)\n File \"/usr/local/lib/pulp/lib64/python3.6/site-packages/pul
pcore/plugin/download/http.py\", line 183, in _run\n response.raise_for_status()\n File \"/usr
/local/lib/pulp/lib64/python3.6/site-packages/aiohttp/client_reqrep.py\", line 942, in raise_for_s
tatus\n headers=self.headers) \n"

}I

"worker": "/pulp/api/v3/workers/e256600c—c8bb-4dec-affe-£f047e617ad50/",
https://github.com/pulp/pulpcore/blob/master/pulpcore/app/models/progress.py#L93-L115

"parent": null,

"spawned_tasks": [],
"progress_reports": [
{
"message": "Downloading Metadata",
"state": "completed",
"total": 1,
"done": 1,
"suffix": null
}I
{
"message": "Downloading Artifacts",
"state": "failed",

"total": 35195,
"done": 35195,
"suffix": null

"message": "Parsing Metadata Lines",
"state": "canceled",

"total": 100000,

"done": 35501,

"suffix": null

"message": "Associating Content",
"state": "canceled",
"total": 35191,
"done": 35191,
"suffix": null
}
]I

"created_resources": []

Related issues:
Related to Pulp - Story #5444 [Epic] Consolidate ProgressReporting into a si... CLOSED - CURRENTRELEASE

History

#1 - 07/21/2019 09:15 PM - jhutar@redhat.com

Just for record, please note it failed for 404 on some files, not on the manifest. But | assume that is not important in this specific issue report. Thank
you!

#2 - 07/23/2019 04:37 PM - amacdona@redhat.com
- Sprint/Milestone set to 3.0.0
- Triaged changed from No to Yes

- Sprint set to Sprint 56

#3 - 08/02/2019 03:15 PM - rchan
- Sprint changed from Sprint 56 to Sprint 57

#4 - 08/26/2019 04:30 PM - rchan
- Sprint changed from Sprint 57 to Sprint 58

#5 - 09/09/2019 10:55 PM - fao89

- Status changed from NEW to ASSIGNED

- Assignee set to fao89
#6 - 09/09/2019 10:58 PM - fao89
- Status changed from ASSIGNED to NEW
- Assignee deleted (fao89)

#7 - 09/10/2019 10:04 PM - fao89
- Status changed from NEW to ASSIGNED

- Assignee set to fao89

#8 - 09/10/2019 11:12 PM - fao89
- Status changed from ASSIGNED to POST

https://github.com/pulp/pulpcore/pull/293
https://github.com/pulp/pulpcore-plugin/pull/127

#9 - 09/13/2019 04:24 PM - rchan
- Sprint changed from Sprint 58 to Sprint 59

#10 - 09/17/2019 11:21 PM - fao89
- Status changed from POST to NEW

- Assignee deleted (fao89)

#11 - 09/17/2019 11:22 PM - fao89

- Related to Story #5444: [Epic] Consolidate ProgressReporting into a single model so it's simpler for plugin writers added

#12 - 09/20/2019 05:08 PM - fao89

- Status changed from NEW to CLOSED - NOTABUG

it's likely been fixed by #5444
